<?php

namespace Drupal\monarch_migration_d7\Plugin\MigrationMapper;

use Drupal\migrate\Row;

/**
 * Maps fields.
 *
 * @MigrationMapper(
 *   id = "monarch_migration_d7_paragraphs",
 *   migration = "paragraphs",
 *   weight = -9999,
 * )
 */
class Paragraphs extends MigrationMapperD7Base {

  /**
   * {@inheritdoc}
   */
  public function prepareRow(Row $row) {
    $row->setDestinationProperty('type', $row->getSourceProperty('bundle'));
    $row->setDestinationProperty('id', $row->getSourceProperty('item_id'));
    $row->setDestinationProperty('revision_id', $row->getSourceProperty('revision_id'));
    $row->setDestinationProperty('parent_type', $row->getSourceProperty('parent_type'));
    $row->setDestinationProperty('parent_id', $row->getSourceProperty('parent_id'));
    $row->setDestinationProperty('parent_field_name', $row->getSourceProperty('field_name'));

    foreach (($this->fieldInfo['paragraphs_item'] = $this->fieldInfo['paragraphs_item'] ?? static::getBundleFields('paragraphs_item')) as $field_name => $field_type) {
      if ($row->hasSourceProperty($field_name)) {
        $row->setSourceProperty($field_name, $this->processField($field_type, $row->getSourceProperty($field_name)));
      }
    }
  }

}
